package	jp.co.sds_corp.volcano;

import jp.co.sds_corp.util.config.IConfiguration;

public class Settings
{
	Settings() {
		position = 0;
		direction = 1;
		reader = 5;
/*
		SimpleDateFormat sdf = new SimpleDateFormat( "yyMMdd" );
		Date dt = new Date();
		url = "http://volceye.edu.kagoshima-u.ac.jp/webcam/archive/"
				+ sdf.format( dt ) + "/";
		width = 640;
		height = 480;
		frameRate = 3;
		interval = 300;
*/
	}

	public void init( IConfiguration config ) throws Exception {
		IConfiguration attr = config.getAttributes();
		width = Integer.valueOf( attr.get( "width" )).intValue();
		height = Integer.valueOf( attr.get( "height" )).intValue();
		frameRate = Integer.valueOf( attr.get( "frameRate" )).intValue();
		reader = Integer.valueOf( attr.get( "reader", "5" )).intValue();
		contentType = attr.get( "contenttype", "video.quicktime" );

		IConfiguration c = config.getChild( "Source" );
		source = createSource( c );
	}

	protected ISource createSource( IConfiguration config ) throws Exception {
		String cls = config.getAttributes().get( "class" );
		ISource ret = (ISource )Class.forName( cls ).newInstance();
		ret.init( config );
		url = ret.getUrl().toString();
		return ret;
	}

	ISource	source;	// データソース
	String	url;	// データのURL
	int	width;	// 画像の幅
	int	height;	// 画像の高さ
	int	frameRate;	// 再生速度
	int	position;	// 表示位置
	int	direction;	// 表示する方向
	int	interval;	// 表示する間隔
	String	contentType;	// 出力する動画のContentType
	int	reader;	// 読み込みスレッド数

	/**
	* データソースを設定します。
	* @param	var		設定するデータ
	*/
	public void setSource( ISource var ) {
		this.source = var;
	}
	/**
	* データソースを取得します。
	* @return	データソース
	*/
	public ISource getSource() {
		return source;
	}

	/**
	* データのURLを設定します。
	* @param	var		設定するデータ
	*/
	public void setUrl( String var ) {
		this.url = var;
	}
	/**
	* データのURLを取得します。
	* @return	データのURL
	*/
	public String getUrl() {
		return url;
	}

	/**
	* 画像の幅を設定します。
	* @param	var		設定するデータ
	*/
	public void setWidth( int var ) {
		this.width = var;
	}
	/**
	* 画像の幅を取得します。
	* @return	画像の幅
	*/
	public int getWidth() {
		return width;
	}

	/**
	* 画像の高さを設定します。
	* @param	var		設定するデータ
	*/
	public void setHeight( int var ) {
		this.height = var;
	}
	/**
	* 画像の高さを取得します。
	* @return	画像の高さ
	*/
	public int getHeight() {
		return height;
	}

	/**
	* 再生速度を設定します。
	* @param	var		設定するデータ
	*/
	public void setFrameRate( int var ) {
		this.frameRate = var;
	}
	/**
	* 再生速度を取得します。
	* @return	再生速度
	*/
	public int getFrameRate() {
		return frameRate;
	}

	/**
	* 表示位置を設定します。
	* @param	var		設定するデータ
	*/
	public void setPosition( int var ) {
		this.position = var;
	}
	/**
	* 表示位置を取得します。
	* @return	表示位置
	*/
	public int getPosition() {
		return position;
	}

	/**
	* 表示する方向を設定します。
	* @param	var		設定するデータ
	*/
	public void setDirection( int var ) {
		this.direction = var;
	}
	/**
	* 表示する方向を取得します。
	* @return	表示する方向
	*/
	public int getDirection() {
		return direction;
	}

	/**
	* 表示する間隔を設定します。
	* @param	var		設定するデータ
	*/
	public void setInterval( int var ) {
		this.interval = var;
	}
	/**
	* 表示する間隔を取得します。
	* @return	表示する間隔
	*/
	public int getInterval() {
		return interval;
	}

	/**
	* 出力する動画のContentTypeを設定します。
	* @param	var		設定するデータ
	*/
	public void setContentType( String var ) {
		this.contentType = var;
	}
	/**
	* 出力する動画のContentTypeを取得します。
	* @return	出力する動画のContentType
	*/
	public String getContentType() {
		return contentType;
	}

	/**
	* 読み込みスレッド数を設定します。
	* @param	var		設定するデータ
	*/
	public void setReader( int var ) {
		this.reader = var;
	}
	/**
	* 読み込みスレッド数を取得します。
	* @return	読み込みスレッド数
	*/
	public int getReader() {
		return reader;
	}

}
